{$include mo_globaldefs.h}
{$typeinfo on}

unit test012port;

interface

uses
   SysUtils,
   math,
   typinfo,
   mo_hub,
   chepersy,
   mo_classes,
   mo_module,
   mo_assets;


type
  TTest12Data = class;
  TT12Array = array of TTest12Data;
  TTest12Data = class (TcgeObject)//TTrulyPersistent)
  public
    all: TT12Array;
///    _666: integer;
    mx, my, r, g, b, ar, ag ,ab, aa, s, dx, dy: glFloat;
//    m: TImageMode;
//    w,h, t: integer;
//    Oopaloopa: Int64;
//    p: pointer;
//    texture: glUint;
    previous, next, first: TTest12Data;
//    BigBin: TBigBin;
    constructor FirstCreate(prv: TTest12Data); virtual;
    procedure RegisterFields; override;
//    procedure InitTexture;
    procedure Render;
    procedure RenderFirst(OffX, OffY, VsizeX, VsizeY, PixelSize: float);
    procedure Cycle(scale: integer = 1);
    procedure CycleNonFriendly;
    procedure CycleFriendly(cheat: integer = 0);
    procedure CycleTestHalf;
    destructor Destroy; override;//procedure Scrape; override;
    procedure Grow;
  end;

Const
  T12Quantity = 50;

implementation

Const
  PrefDist = 5.0;
  PrefSize = 64.0;
  Speed = 1.0;
  AddPerFrame = 1;
  ColorWaveSpeed = 2;


  constructor TTest12Data.FirstCreate(prv: TTest12Data);
   begin
 ///    _666:=666;
     ar:=1;
     ag:=1;
     ab:=1;
     aa:=0.75;
     s:=PrefSize;
     r:=0.15;
     g:=0.25;
     b:=0.5;
     if not Assigned(prv) then begin
       SetLength(all, 1);
       all[0]:= Self;
       first:= Self;
       mx:= Mother^.Display.WindowClientRect.Width/2;
       my:= Mother^.Display.WindowClientRect.Height/2;
     end
     else begin
       first:= prv;
       previous:= first.all[High(first.all)];
       SetLength(first.all, Length(first.all) +1);
       first.all[High(first.all)]:= Self;
       previous.next:= Self;

       mx:= previous.mx + (Random() - 0.5) * 1000;
       my:= previous.my + (Random() - 0.5) * 1000;
     end;
     //InitTexture();
   end;

  procedure TTest12Data.RegisterFields;
  begin
//      RegType(TypeInfo(TImageMode));
//      RegType('TBigBin', TypeInfo(integer), SizeOf(TBigBin));
  //    RegType(TypeInfo(glUint), SizeOf(glUint), nil);
  //    RegType(TypeInfo(glFloat), SizeOf(glFloat), nil);
      RegType(typeinfo(tt12array));//, typeinfo(tcgeobject)); //***TODO CPS_Managed_object);
      inherited;
      ListFields([
        'all', @all, typeinfo(tt12array),
//        '_666', @_666, TypeInfo(integer),
        'mx', @mx, TypeInfo(glFloat),
        'my', @my, TypeInfo(glFloat),
        'r', @r, TypeInfo(glFloat),
        'g', @g, TypeInfo(glFloat),
        'b', @b, TypeInfo(glFloat),
        'ar', @ar, TypeInfo(glFloat),
        'ag', @ag, TypeInfo(glFloat),
        'ab', @ab, TypeInfo(glFloat),
        'aa', @aa, TypeInfo(glFloat),
        's', @s, TypeInfo(glFloat),
        'dx', @dx, TypeInfo(glFloat),
        'dy', @dy, TypeInfo(glFloat),
//        'm', @m, TypeInfo(TImageMode),
//        'w', @w,
//        'h', @h,
//        't', @t, TypeInfo(integer),
 //       'oopaloopa', @Oopaloopa, TypeInfo(Int64),
//        '-p', @p, TypeInfo(pointer),
//        '-texture', @texture, TypeInfo(glUint),
        'previous', @previous, TypeInfo(TTest12data),
        'next', @next, TypeInfo(TTest12data),
        'first', @first, TypeInfo(TTest12data)
      ]);


      {
      RegField('_666', @_666, TypeInfo(integer));
      RegField('mx', @mx, TypeInfo(glFloat));
      RegField('my', @my, TypeInfo(glFloat));
      RegField('r', @r, TypeInfo(glFloat));
      RegField('g', @g, TypeInfo(glFloat));
      RegField('b', @b, TypeInfo(glFloat));
      RegField('ar', @ar, TypeInfo(glFloat));
      RegField('ag', @ag, TypeInfo(glFloat));
      RegField('ab', @ab, TypeInfo(glFloat));
      RegField('aa', @aa, TypeInfo(glFloat));
      RegField('s', @s, TypeInfo(glFloat));
      RegField('dx', @dx, TypeInfo(glFloat));
      RegField('dy', @dy, TypeInfo(glFloat));
      RegField('m', @m, TypeInfo(TImageMode));
      RegField('oopaloopa', @Oopaloopa, TypeInfo(Int64));
      RegField('w', @w, TypeInfo(integer));
      RegField('h', @h, TypeInfo(integer));
      RegField('t', @t, TypeInfo(integer));
      RegSkip('p', @p, TypeInfo(pointer));
      RegSkip('texture', @texture, TypeInfo(glUint));
      RegField('previous', @previous, TypeInfo(TTest12data));
      RegField('next', @next, TypeInfo(TTest12data));
      RegField('last', @last, TypeInfo(TTest12data));
  //    RegField('BigBin', @BigBin, TypeInfo(TBigBin));
    }
  end;

  procedure TTest12Data.CycleNonFriendly;
  var
    distance,
    force: float;
    dmx, dmy: float;
    i: integer;
  begin
    if Assigned(next) then next.CycleNonFriendly;
    if Assigned(next) then begin
      if Assigned(previous) then begin
      distance:=sqrt(sqr(previous.mx - mx) + sqr(previous.my - my));
        if distance < 1 then distance:=1;
        force:= - speed * 0.01 * sqr(PrefDist)/sqr(Distance);
        if force < -5 then force:=-5;
    //    force:=aa * force;
        dmx:= (previous.mx - mx) / distance;
        dmy:= (previous.my - my) / distance;
        mx += force * dmx;
        my += force * dmy;
      end;
    end;
    if Assigned(previous) then begin
      ag:=previous.ag;
      ab:=previous.ab;
      ar:=previous.ar;
      aa:=previous.aa;
      distance:=sqrt(sqr(previous.mx - mx) + sqr(previous.my - my));
      if distance < 1 then distance:=1;
      dmx:= (previous.mx - mx) / distance;
      dmy:= (previous.my - my) / distance;
      if distance > PrefDist
        then begin
          force:= speed * 0.1 * (distance - PrefDist);
          if ag < 0.5 then force:= -force;
        end
        else force:= - speed * 0.1 * PrefDist/Distance;
      if force > 50 then force:=50;
      if force < -5 then force:= -5;
   //   force:=aa * force;
      mx += force * dmx + dx;
      my += force * dmy + dy;

      if mx < -1000 then mx:= -1000;
      if mx > Mother^.Display.WindowClientRect.Width + 1000 then mx:=Mother^.Display.WindowClientRect.Width + 1000;
      if my < -1000 then my:= -1000;
      if my > Mother^.Display.WindowClientRect.Height + 1000 then my:= Mother^.Display.WindowClientRect.Height + 1000;

      dx += Speed * 0.01 * (random() - 0.5);
      dx *= 0.98;
      dy += Speed * 0.01 * (random() - 0.5);
      dy *= 0.98;
     // s += Speed * 0.01 * (PrefSize * (PrefDist/distance) - s);
    end;

    distance:=sqrt(sqr(Module.Logic.mousex - mx) + sqr(Module.Logic.mousey - my));
    if distance < 1 then distance:=1;
    dmx:= (Module.Logic.mousex - mx) / distance;
    dmy:= (Module.Logic.mousey - my) / distance;
    force:=0;
    if ar < 0.5 then force -= speed * 1 * PrefDist / Distance;
    if ab < 0.5 then force += 0.1;
    if force > 5 then force:=5;
    if force < -5 then force:= -5;
  //  force:=aa * force;
    mx += force * dmx;
    my += force * dmy;
  end;

  procedure TTest12Data.CycleFriendly(cheat: integer = 0);
  var i, step, k, o: integer;
  begin
    if Self <> first then Die(RuEn(
      'Метод CycleFriendly() имеет смысл вызывать только у первого объекта верёвочки.'#10#13'  Искренне ваш, Капитан Очевидность.',
      'The  CycleFriendly() has to be called only on the forst object of the rope.'#10#13'  Sincerely yours, Captain Obvious.'));
    if cheat = 0 then begin
      for i:= High(all) downto 0 do all[i].Cycle;
    end
    else begin
      step:= Math.Max(1, round(Length(all) / 10000));
      i:= cheat mod step;
      repeat
        all[i].Cycle(step);
        i+= step;
      until i >= High(all);
    end
  end;

  procedure TTest12Data.CycleTestHalf;
  var
    i, halfwidth: integer;
  begin
    halfwidth:= length(all) div 2;
    for i:= 0 to halfwidth do  begin
      all[i].Cycle;
      all[High(all) - i].Cycle;
    end;
  end;


  procedure TTest12Data.Cycle(scale: integer = 1);
  var
    distance,
    force: float;
    dmx, dmy: float;
    i: integer;
  begin
    if Assigned(next) then begin
      if Assigned(previous) then begin
      distance:=sqrt(sqr(previous.mx - mx) + sqr(previous.my - my));
        if distance < 1 then distance:=1;
        force:= - speed * 0.01 * sqr(PrefDist)/sqr(Distance);
        if force < -5 then force:=-5;
    //    force:=aa * force;
        dmx:= (previous.mx - mx) / distance;
        dmy:= (previous.my - my) / distance;
        mx += force * dmx * scale;
        my += force * dmy * scale;
      end;
    end;
    if Assigned(previous) then begin
      ag:=previous.ag;
      ab:=previous.ab;
      ar:=previous.ar;
      aa:=previous.aa;
      distance:=sqrt(sqr(previous.mx - mx) + sqr(previous.my - my));
      if distance < 1 then distance:=1;
      dmx:= (previous.mx - mx) / distance;
      dmy:= (previous.my - my) / distance;
      if distance > PrefDist
        then begin
          force:= speed * 0.1 * (distance - PrefDist);
          if ag < 0.5 then force:= -force;
        end
        else force:= - speed * 0.1 * PrefDist/Distance;
      if force > 50 then force:=50;
      if force < -5 then force:= -5;
   //   force:=aa * force;
      mx += (force * dmx + dx) * scale;
      my += (force * dmy + dy) * scale;

      if mx < -1000 then mx:= -1000;
      if mx > 3000//Mother^.Display.WindowClientRect.Width + 1000
        then mx:=3000;//Mother^.Display.WindowClientRect.Width + 1000;
      if my < -1000 then my:= -1000;
      if my > 2000//Mother^.Display.WindowClientRect.Height + 1000
      then my:= 2000;//Mother^.Display.WindowClientRect.Height + 1000;

//      dx += Speed * 0.01 * (random() - 0.5);
      dx *= 0.98;
//      dy += Speed * 0.01 * (random() - 0.5);
      dy *= 0.98;
     // s += Speed * 0.01 * (PrefSize * (PrefDist/distance) - s);
    end;

    distance:=sqrt(sqr(Module.Logic.mousex - mx) + sqr(Module.Logic.mousey - my));
    if distance < 1 then distance:=1;
    dmx:= (Module.Logic.mousex - mx) / distance;
    dmy:= (Module.Logic.mousey - my) / distance;
    force:=0;
    if ar < 0.5 then force -= speed * 1 * PrefDist / Distance;
    if ab < 0.5 then force += 0.1;
    if force > 5 then force:=5;
    if force < -5 then force:= -5;
  //  force:=aa * force;
    mx += force * dmx * scale;
    my += force * dmy * scale;
  end;

  procedure TTest12Data.Grow;
  var i: integer;
  begin
    For i:=1 to AddPerFrame do TTest12Data.FirstCreate(self);
  end;

  destructor TTest12Data.Destroy;//procedure TTest12Data.Scrape;
  begin
    if Assigned(next) then next:= nil;
    SetLength(all, 0);
    inherited;
  end;

  procedure TTest12Data.Render;
  begin
  {    glBegin(GL_QUADS);//GL_TRIANGLES);
        glNormal3f( 0.0, 0.0, 1.0);
  }
      glColor4f(ar, ag, ab , aa);
      with Mother^.Display.WindowClientRect do begin
        glVertex2f(mx - 1, my + 1);  //top left
        glVertex2f(mx + 1, my + 1);
        glVertex2f(mx + 1, my - 1);
        glVertex2f(mx - 1, my - 1);
      end;
{        glTexCoord2f(0, 0);
        glVertex2f(mx - s/2, DisplayHeight() - my + s/2);  //top left
        glTexCoord2f(1, 0);
        glVertex2f(mx + s/2, DisplayHeight() - my + s/2);
        glTexCoord2f(1, 1);
        glVertex2f(mx + s/2, DisplayHeight() - my - s/2);
        glTexCoord2f(0, 1);
        glVertex2f(mx - s/2, DisplayHeight() - my - s/2);
      glEnd;
  }
    //if Assigned(previous) then previous.Render();
  end;

  procedure TTest12Data.RenderFirst(OffX, OffY, VsizeX, VsizeY, PixelSize: float);
  var i, j: integer;
  begin
    if aa > 1 then aa:=1;
    if aa < 0 then aa:=0;
    //s:=s + 0.01 * (64 - s);
    //if s > 128 then s:=128;

    r+=(random() - 0.5)*0.007;
    if r > 0.4 then r:=0.4;
    if r < 0 then r:=0;

    g+=(random() - 0.5)*0.007;
    if g > 0.4 then g:=0.4;
    if g < 0 then g:=0;

    b+=(random() - 0.5)*0.007;
    if b > 0.4 then b:=0.4;
    if b < 0 then b:=0;


    glEnable(GL_ALPHA_TEST);
    //glDisable(GL_BLEND);
    glEnable(GL_BLEND);
    glAlphaFunc(GL_GREATER, 0);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glDisable(GL_CULL_FACE);
    glDisable(GL_DEPTH_TEST);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glOrtho(OffX, VsizeX + OffX, offy, vsizey+offy, 0 ,1);

    {glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D, texture);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);	// Linear Filtered
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR_MIPMAP_LINEAR);	// Linear Filtered
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
    }

    //glEnable(GL_POINT_SMOOTH);
    //glPointSize(3 / PixelSize);
//    glBegin(GL_POINTS);
    glBegin(GL_QUADS);
    try
//      j:= Math.Max(0, High(all) - 10000);
      for i:= Math.Min(10000, High(all)) downto 0 do all[i].Render;
      //Last.Render(); //transparency isue
    except
      Die('Render crashed');
    end;
    glEnd;

  end;


end.
