  procedure CollateWarningsFromAllThreads;
  //ONLY call this from the main thread
  var
    pes: PMotherSehState;
    FoundAny: boolean = false;
    tn: UnicodeString;
    i: integer;
  begin
    pes:= @Mother^.ExceptionState;
    while Assigned (pes^.Next) do begin
      pes:= pes^.Next;
      if Length(pes^.Warnings) > 0 then begin
        FoundAny:= true;
        break;
      end;
    end;

    //just a reminder: this shit is displayed backwards, from the last lines to the first!

    if not FoundAny then exit;
    with Mother^.ExceptionState do begin
      if Length(Warnings) > 0 then begin
        SetLength(Warnings, Length(Warnings) + 1);
        Warnings[High(Warnings)]:= RuEn(
          #10#13'Основной поток:',
          #10#13'Main thread:');
      end;

      pes:= @Mother^.ExceptionState;
      while Assigned (pes^.Next) do begin
        pes:= pes^.Next;
        if Length(pes^.Warnings) = 0 then continue;
        SetLength(Warnings, Length(Warnings) + 1);
        Warnings[High(Warnings)]:= RuEn(
          #10#13'Основной поток:',
          #10#13'Main thread:');
        if pes^.ThreadTitle <> ''
          then tn:= pes^.ThreadTitle
          else tn:= RuEn('Поток ID=', 'Thread ID=') + IntToHex(pes^.ThreadId, 8) + 'h :';

        for i:= 0 to High(pes^.Warnings) do begin
          SetLength(Warnings, Length(Warnings) + 1);
          Warnings[High(Warnings)]:= pes^.Warnings[i];
        end;

        SetLength(Warnings, Length(Warnings) + 1);
        Warnings[High(Warnings)]:= #10#13 + tn;

        SetLength(pes^.Warnings, 0);
      end;
    end;
  end;
