
{$ifdef FPC_REQUIRES_PROPER_ALIGNMENT}
  {$fatal NOT COMPATIBLE}
{$endif}


{ copy-pasted from the FPC RTL (unit system) }

type
   pdynarray = ^tdynarray;
   tdynarray = packed record
      refcount : ptrint;
      high : tdynarrayindex;
   end;

Procedure int_Addref (Data, TypeInfo : Pointer); [external name 'FPC_ADDREF'];


//***TODO: Do something with this cthulhack! My eyes are bleeding! ARGH!!!

Procedure NewDynArray(parray: pointer; Len, ElementTypeInd: integer);
begin
  pointer(parray^):= nil;

  //!!!
  SetLength(TArrayOfByte(parray^), Len * Types[ElementTypeInd].Size);

  if Len > 0 then  //high value in FreePascal, length  in Delphi

//***TODO: Inefficient! Clears the memory but this routine is used before rewriting the array memory anyway!

    pdynarray(ptruint(pointer(parray)^) - ptruint(sizeof(tdynarray)))^.high:= Len - 1;
{
  {$ifdef fpc}
    dword((pointer(parray^) - 4)^):= Len - 1;
  {$else}
    dword(pointer(cardinal(parray^) - 4)^):= Len;
  {$endif}
}
end;

function GetDynArrayLength(parray: pointer): integer;
begin
  Result:= pdynarray(ptruint(pointer(parray)^) - ptruint(sizeof(tdynarray)))^.high + 1;
//  Result:= longint(pointer(pointer(parray^) - 4)^) {$ifdef fpc} + 1{$endif}
              //the value at -4 contains Length() in Delphi
              //and High() (i.e. Length() -1 ) in FreePascal
end;

//Chepersy is NOT  thread-safe. Designed for a single-threaded architecture

procedure IncDynArrayRefCount(parray: pointer);
begin
  if Assigned (pointer(parray^)) then
    Inc(pdynarray(ptruint(pointer(parray)^) - ptruint(sizeof(tdynarray)))^.refcount);
end;

procedure IncRawByteStringRefCount(ps: pointer);
begin
  if Assigned(ps) then inc(longint(pointer(ptruint(ps) - 8)^));
end;

procedure IncUnicodeStringRefCount(ps: pointer);
begin
  if Assigned(ps) then inc(longint(pointer(ptruint(ps) - 8)^));
end;

procedure IncWideStringRefCount(ps: pointer);
begin
  if Assigned(ps) then inc(longint(pointer(ptruint(ps) - 8)^));
end;

  (*  0.8.1 --> 0.8.2,  15 Feb. 2008
       A fatal blunder detected.
         Who said the standard dynamic array
         memory manager allocates exactly the
         same amount of bytes as the array length?
         it could be rounded up to anything.

       My application started crashing with all the signs of
         trashed heap after I tried to used chepersy
         in combination with array of byte.

   P.S. Just as I thought, the dynamic arrays
     use *different* allocator than the GetMem() procedure. Go tell.


Procedure NewDynArray(parray: pointer; Len, ElementTypeInd: integer);
var
  p: pointer;
begin
  if Len = 0 then pointer(parray^):=nil
  else begin
    GetMem(p, 8 + Len * Types[ElementTypeInd].Size);
    dword(parray^):=dword(p) + 8;
    dword(p^):=1; //reference count
    dword(pointer(cardinal(p) + 4)^)
      :=Len {$ifdef fpc} - 1{$endif}; //high value in FreePascal, length  in Delphi
  end;
end;

*)
