procedure TGame.Tick;
begin

end;

procedure TGame.Pulse(ticks: integer);
begin

end;


constructor TAbstractGame.Create;
var i: integer;
begin
  inherited;
  for i:=0 to 1 do Self.RefCounts[i]:= TSparceLongintArray.Create;
end;

procedure TAbstractGame.RegisterFields;
begin
  RegClass(TGameLayer);
  RegType(typeinfo(TGameObjectRefCounts), typeinfo(TSparceLongintArray), [0,1]);
  inherited;
  ListFields([
    'baselayer', @BaseLayer, typeinfo(TGameLayer),
    'refcounts', @RefCounts, typeinfo(TGameObjectRefCounts),
    'currentlayer', @CurrentLayer, CPS_POINTER
  ]);

end;

procedure TGameObject.RegisterFields;
begin
  inherited;
  ListFields([
    'Index', @Index,
    //'RefCount', @RefCount,
    'LastTicked', @LastTicked,
    'NextTicks', @NextTicks, typeinfo(Longint)
  ]);
end;

function TGameObject.CloneAnother(another: TChepersyObject): boolean;
var
  //rc,
    i: Longint;
begin
  //rc:= RefCount;
  i:= Index;
  Result:= inherited CloneAnother(another);
  //RefCount:= rc;
  Index:= i;
end;

procedure TGameObject.Scrape; //only really scrape if refcount reaches zero
var
  i, a, r: longint;
begin
  i:= Self.Index shr 31;
  a:= abs(Self.Index);
  r:= Game.RefCounts[i][a];
  if r > 0 then Game.RefCounts[i][a]:= r - 1;
  Game.CurrentLayer.Remove(Self.Index);
  if r <= 1 then inherited;
end;

constructor TGameObject.Create;
begin


end;

procedure TPhysicalGameObject.RegisterFields;
begin
  inherited;


end;


