type
  TGAPIAbstractionLayer = class
  public
    //substitute for glOrtho unavalilable in GL ES
    class procedure Ortho(left, right, bottom, top,  nearVal, farVal: GLfloat);
    class procedure OrthoApplicationWindow;
    class procedure SetGLStatesForGUI;
  end;


  TAbstractMesh = class {$ifndef cgekernel}(TRenderable){$endif}
  public
    {$ifdef cgekernel} procedure Render;  virtual; abstract; {$endif}
  end;


  TDumbUniMesh = class (TAbstractMesh)
  public
    colors: array of TVector4f;
    normals, texcoords: array of TVector3f;
    vertices: array of TVector4f;
    indices: array of GLushort; //word
    matrix: TMatrix4f;

    //assumes origin in *upper* left corner (y axis downwards, z axis towards the viewer)
    procedure AddQuad2d(r, g, b, a, left, top, right, bottom, txleft, txtop, txright, txbottom: GLfloat);
    procedure Render; override;
  protected
    maxVertex, maxIndex: integer;
  end;
