{
    This file is part of Chentrah,
    Copyright (C) 2004-2008 Anton Rzheshevski (chebmaster@mail.ru).

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see http://www.gnu.org/licenses/

 **********************************************************************}


 var
   _UniToAnsiTable: array[0..$FFFF] of AnsiChar;
   _AnsiToUniTable: array[AnsiChar] of UnicodeChar;

 procedure InitUnicode;
 
(* function AnsiToUni(s: AnsiString): TUni;
 function WideToUni(w: UnicodeString): TUni;*)

 //Note: the system code page in Windows and the console code page *differ*!
 //  (so you'd only get a garbled mess if you simply use WriteLn
 //   without converting your text manually).
 //While WideToAnsi calls UnicodeCharToMultiByte(0, ...) to use the default
 //  code page (usually cp1251, Russian for Windows), WideToConsole calls
 //  UnicodeCharToMultiByte(GetConsoleOutputCP(), ...) to use the actual console
 //  code page (usually cp866, Russian for MS-DOS).
 //In Linux most of these functions call Utf8Encode, behaving identically.


 function FileNameToUnicode(f: TFileNameString): UnicodeString;
 function UnicodeToFileName(u: UnicodeString): TFileNameString;

 function FileNameToUtf8(f: TFileNameString): Utf8String;
 function Utf8ToFileName(u: Utf8String): TFileNameString;

 function WideToAnsi(u: UnicodeString): AnsiString; overload;
 function WideToConsole(u: UnicodeString): RawByteString; //used by debug build to WriteLn() log to console window
 function AnsiToWide(a: RawByteString): UnicodeString;
 function WideToFileName(u: UnicodeString): TFileNameString; overload;
 function FileNameToWide(f: TFileNameString): UnicodeString;
 function WideToCp1251(u: UnicodeString): AnsiString1251;
 function Cp1251ToWide(a: AnsiString1251): UnicodeString;
 function Cp1251CharToUnicodeChar(a: AnsiChar): UnicodeChar;
 function TrimUnicodeString (u: UnicodeString): UnicodeString;
{$if FPC_FULLVERSION < 20700}
  function WideReplace(u: UnicodeString; a, b: AnsiString): UnicodeString;
                                                                    overload;
 function WideReplace(u: UnicodeString; a: AnsiString; b: UnicodeString): UnicodeString;
                                                                    overload;
{$endif}

  function WideReplace(u, a, b: UnicodeString): UnicodeString;
                              {$if FPC_FULLVERSION < 20700} overload;{$endif}
 function WidePos(a, u: UnicodeString): integer;

type
 UnicodeStringArray = array of UnicodeString;
 RawByteStringArray = array of RawByteString;
 function Explode(separator, s: UnicodeString; TrimIt: system.boolean = false): UnicodeStringArray; overload;
 function Explode(separator, s: RawByteString; TrimIt: system.boolean = false): RawByteStringArray; overload;
 function Implode(separator: RawByteString; a: RawByteStringArray): RawByteString; overload;
 function Implode(separator: UnicodeString; a: UnicodeStringArray): UnicodeString; overload;

Function StrReplace (S, zamenjaemoe, zamenjajushee:RawByteString): RawByteString;  OVERLOAD;
Function StrReplace (S, zamenjaemoe, zamenjajushee:UnicodeString): UnicodeString;  OVERLOAD;
