    function TUnicodeStringContainer.Add(s: UnicodeString): integer;
    begin
      SetLength(a, system.Length(a) + 1);
      a[system.High(a)]:= s;
      Result:= system.High(a);
    end;

    function TUnicodeStringContainer.Length: integer;
    begin
      Result:= system.Length(a);
    end;

    function TUnicodeStringContainer.High: integer;
    begin
      Result:= system.High(a);
    end;

    function TUnicodeStringContainer.Last: UnicodeString;
    begin
      Result:= a[system.High(a)];
    end;

    procedure TUnicodeStringContainer.Delete(i: integer);
    begin
      if (i < system.High(a)) then a[i]:= a[system.High(a)];
      SetLength(a, system.High(a));
    end;

    procedure TUnicodeStringContainer.Clear;
    begin
      SetLength(a, 0);
    end;

    function TUnicodeStringContainer._Read(i: integer): UnicodeString;
    begin
      Result:= a[i];
    end;

    procedure TUnicodeStringContainer._Write(i: integer; s:UnicodeString);
    begin
      a[i]:= s;
    end;

    function TObjectContainer.Add(o: TObject): integer;
    begin
      SetLength(a, system.Length(a) + 1);
      a[system.High(a)]:= o;
      Result:= system.High(a);
    end;

    function TObjectContainer.Length: integer;
    begin
      Result:= system.Length(a);
    end;

    function TObjectContainer.High: integer;
    begin
      Result:= system.High(a);
    end;

    function TObjectContainer.Last: TObject;
    begin
      Result:= a[system.High(a)];
    end;

    procedure TObjectContainer.Delete(i: integer);
    begin
      if (i < system.High(a)) then a[i]:= a[system.High(a)];
      SetLength(a, system.High(a));
    end;

    procedure TObjectContainer.Clear;
    begin
      SetLength(a, 0);
    end;

    function TObjectContainer._Read(i: integer): TObject;
    begin
      Result:=a[i];
    end;

    procedure TObjectContainer._Write(i: integer; o: TObject);
    begin
      a[i]:= o;
    end;
{
    function TAssetRecordContainer.Add(o: TAssetRecord): integer;
    begin
      SetLength(a, system.Length(a) + 1);
      a[system.High(a)]:= o;
      Result:= system.High(a);
    end;

    function TAssetRecordContainer.Length: integer;
    begin
      Result:= system.Length(a);
    end;

    function TAssetRecordContainer.High: integer;
    begin
      Result:= system.High(a);
    end;

    function TAssetRecordContainer.Last: PAssetRecord;
    begin
      Result:= @a[system.High(a)];
    end;

    procedure TAssetRecordContainer.Delete(i: integer);
    begin
      if (i < system.High(a)) then a[i]:= a[system.High(a)];
      SetLength(a, system.High(a));
    end;

    procedure TAssetRecordContainer.Clear;
    begin
      SetLength(a, 0);
    end;

    function TAssetRecordContainer._Read(i: integer): PAssetRecord;
    begin
      Result:=@a[i];
    end;

    procedure TAssetRecordContainer._Write(i: integer; o: PAssetRecord);
    begin
      a[i]:= o^;
    end;
}
