
	  Mother:= new(PMother);

    FillChar(Mother^, SizeOf(PMother^), 0);

    {$ifdef debug_build}
      Mother^.Debug.Enabled:= true;
      Mother^.Debug.Verbose:= true;
      Mother^.Debug.ShowFrameNumbersInLog:= true;
    {$endif}
    Mother^.Module.CurrentlyExecutingInd:= NOT_A_MODULE;
    Mother^.Timer.FPS:= 99.0;
    Mother^.Timer.QF:= 99.0;
    Mother^.State.PhysMemory:= GetPhysicalMemorySize();
    Mother^.Display.FadeIn:= 0.0;
    Mother^.Display.BlackoutBegin:= Now() + INITIAL_BLACKOUT / SecondsPerDay;
    Mother^.Display.LogoAnimationStart:= Mother^.Display.BlackoutBegin;
    Mother^.Display.LogoAnimationPlaying:= No; //changes to Yes later
    Mother^.Module.NeedToKeepAssets:= @CgeNeedToKeepModuleResources;
    Mother^.State.ProcessID:= GetProcessID();
    Mother^.State.MainThreadId:= GetCurrentThreadId();
    Mother^.ExceptionState.ThreadId:= GetCurrentThreadId();
    Mother^.ExceptionState.ThreadTitle:= 'main thread';
    Mother^.ExceptionState.AbbrTitleForIndicator:= 'mai'; //fpc 3.0.1 x86_64 always raises an AV here
   {$ifdef windows}
     //Mother^.ExceptionState.StackSegment:= <current ss>;
     // This is only needed for the Windows-only SEH hack.
     {$ifdef cpu64}
      asm
        mov rbx, qword[Mother]
        mov ax, ss
        mov word[rbx + TMother.ExceptionState.StackSegment], ax
      end ['rbx', 'ax'];
     {$else}
      asm
        mov esi, dword[Mother]
        mov ax, ss
        mov word[esi + TMother.ExceptionState.StackSegment], ax
      end ['esi', 'ax'];
     {$endif}
   {$endif}
    Mother^.GAPI.RendererAlias:= ''; // driver name sanated for use in a file name.
      // to store settings separate for each videocard/driver
      // empty string is used as a flag: do not create the INI file //'_unknown_';
    InitCriticalsection(Mother^.CriticalSection);
    InitCriticalSection(Mother^.SehCriticalSection);
    _GenHash(PAssetHash(@(Mother^.State.RunSessionHash)));
    Mother^.State.RunSessionHash.NameMd5:= Md5String('Chentrah');
    pointer(Mother^.Core.ValidateVersion):= @_ValidateVersion;
    pointer(Mother^.Core.ValidateTypesets):= @_ValidateTypesets;
    pointer(Mother^.Core.ValidateTypesetsEq):= @_ValidateTypesetsEq;
    pointer(Mother^.Core.ValidateTypesetsLe):= @_ValidateTypesetsLe;

    pointer(Mother^.Core.AllocateThreadExceptionState):= @_AllocateThreadExceptionState;

    pointer(Mother^.Module.StopDying):= @_ModuleStopDying;
    pointer(Mother^.Module.StartDying):= @_HostDyellW;

    pointer(Mother^.Core.RequestExit):= @_RequestExit;
    pointer(Mother^.Core.IsGoingDownHard):= @GoingDownHard;
//    pointer(Mother^.Core.MainLoopHeartBeat):= @_cgeHeartBeat;
//!    pointer(Mother^.Core.StopDying):= @_exp_StopDying;  //M: StopDying

    InitCriticalSection(Mother^.Core.DbgSayCriticalSection);
    pointer(Mother^.Core.DbgSay):= @DbgSayW;
//!    pointer(Mother^.Core.SetDying):= @SetDying;

    pointer(Mother^.Core.LogW):= @_HostLogW;
    pointer(Mother^.Core.MsgToString):= @_HostMsg;
    pointer(Mother^.Core.AddLogOK):= @AddLogOK;
    pointer(Mother^.Core.GetAssetStorageMemoryStream):= @CgeGetAssetStorageMemoryStream;
    pointer(Mother^.Core.SetAssetStorageMemoryStream):= @CgeSetAssetStorageMemoryStream;
    InitCriticalSection(Mother^.Core.AssetStorageCriticalSection);
    pointer(Mother^.Core.DisplaySessionFailedErrorMessage):= @FatalityMessageBox;
	
    Mother^.Image.CorrectThreadId:= GetCurrentThreadId(); //the module replaces this
      //with its image processing thread id
    pointer(Mother^.Image.Delete):= @DeletePic;
    pointer(Mother^.Image.Load):= @LoadPic;
    pointer(Mother^.Image.LoadAs):= @LoadPicAs;
    pointer(Mother^.Image.LoadFromMem):= @LoadPicFromMem;
    pointer(Mother^.Image.LoadFromMemAs):= @LoadPicFromMemAs;
    pointer(Mother^.Image.Create):= @CreatePic;
    pointer(Mother^.Image.Save):= @SavePic;
    pointer(Mother^.Image.Resize):= @ResizePic;
    pointer(Mother^.Image.Resample):= @ResamplePic;
    pointer(Mother^.Image.Clone):= @ClonePic;
    pointer(Mother^.Image.CloneResample):= @CloneResamplePic;
    pointer(Mother^.Image.GetFmt):= @GetPicFmt;
    pointer(Mother^.Image.SetFmt):= @SetPicFmt;
    pointer(Mother^.Image.GetPixels):= @GetPicPixels;
    pointer(Mother^.Image.GetWidth):= @GetPicWidth;
    pointer(Mother^.Image.GetHeight):= @GetPicHeight;
    pointer(Mother^.Image.GetBytes):= @GetPicBytes;

    pointer(Mother^.Timer.Second):= @Second;
    pointer(Mother^.Timer.UsecDelta):= @UsecDelta;
    pointer(Mother^.Timer.HiResSleep):= @HiResSleep;
	
    pointer(Mother^.Display.LoadBackgroundFromFile):= @_cgeSetBackground;
    pointer(Mother^.Display.LoadBackgroundFromMemoryMappedFile):= @_cgeSetBackgroundPtr;
    pointer(Mother^.Display.RenderBackground):= @_cgeDrawBackground;
    pointer(Mother^.Display.GetWindowExists):= @GetWindowExists;
    pointer(Mother^.Display.SetWindowName):= @SetWindowname;
    pointer(Mother^.Display.BeginBlackout):= @BeginBlackout;
	
//    pointer(Mother^.Display.MousePointer.LoadFromFile):= @CgeLoadCursorFromFile;
//    pointer(Mother^.Display.MousePointer.LoadFromMemory):= @CgeLoadCursorFromMemory;
    pointer(Mother^.Display.MousePointer.LoadFromRawPixmap):= @CgeLoadCursorFromRawPixmap;
    pointer(Mother^.Display.MousePointer.LoadEmpty):= @CgeEmptyCursor;
    pointer(Mother^.Display.MousePointer.LoadDefault):= @CgeStandardCursor;
    pointer(Mother^.Display.MousePointer.LoadHourglass):= @CgeHourglassCursor;


{
в баню
    pointer(Mother^.Text.StringHeightToFontFace):= @cgeffSizeToFace;
    pointer(Mother^.Text.FitStringIntoRectangle):= @cgeffFitStringIntoRectangle;
    pointer(Mother^.Text.GetStringWidth):= @cgeffGetStringWidth;
    pointer(Mother^.Text.GetStringHeight):= @cgeffGetStringHeight;
    pointer(Mother^.Text.SetRenderState):= @cgeffSetRenderState;
    pointer(Mother^.Text.RenderString):= @cgeffRenderString;
}

    pointer(Mother^.Sound.GetOPenALProcAddress):= @exGetALProcAddress; //M: GetALProcAddress
    pointer(Mother^.Sound.NewData):= @CgeNewSoundData;
    pointer(Mother^.Sound.SetVolume):= @CgeSetSoundVolume;
    pointer(Mother^.Sound.PlayFromFile):= @_PlaySound;	
	
//!    pointer(Mother^.Input.GetEventElement):= @_GetCGM;

    pointer(Mother^.Config.SetInt):= @_SetConfigInt;
    pointer(Mother^.Config.GetInt):= @_GetConfigInt;
    pointer(Mother^.Config.GetIntWithCheck):= @_GetConfigIntCh;
    pointer(Mother^.Config.SetString):= @_SetConfigStr;
    pointer(Mother^.Config.GetString):= @_GetConfigStr;
	
    pointer(Mother^.GAPI.SwapBuffers):= @_CgeSwapBuffers;
    pointer(Mother^.GAPI.BuildAlphaMipmaps):= @_CgeBuildAlphaMipmaps;
    pointer(Mother^.GAPI.GetProcAddress):= @exGetGlProcAddress; //M: GetGLProcAddress
    pointer(Mother^.GAPI.GetProcAddress2):= @exGetGlProcAddress2; // M: GetGLProcAddress2
//!    pointer(Mother^.GAPI.GetHigherPowerOf2):= @GetHigherPowerOf2;
//!    pointer(Mother^.GAPI.GetLowerPowerOf2):= @GetLowerPowerOf2;
	
 //!   pointer(Mother^.FileManager.MakeSurePathExists):= @_MakeSurePathExists;
 //!   pointer(Mother^.FileManager.UnmangleFileName):= @_UnmangleFileName;
 //!   pointer(Mother^.FileManager.MangleFileName):= @_MangleFileName;
 //!   pointer(Mother^.FileManager.GetFileHash):= @_GetFileHash;
 //!   pointer(Mother^.FileManager.GetFileDateTime):= @_GetFileDateTime;
 //!   pointer(Mother^.FileManager.GetIsHashvalid):= @_GetIsHashvalid;
	
    pointer(Mother^.AssetKeeper.GenHash):= @GenHash;
//    pointer(Mother^.AssetKeeper.Store):= @StoreResource;
//    pointer(Mother^.AssetKeeper.Claim):= @ClaimResource;
//    pointer(Mother^.AssetKeeper.GetFirst):= @GetFirstResource;
//    pointer(Mother^.AssetKeeper.GetNext):= @GetNextResource;
//    pointer(Mother^.AssetKeeper.ClearList):= @ClearResourceList;
//    pointer(Mother^.AssetKeeper.HashesMatch):= @HashesMatch;

	
    pointer(Mother^.Memory.CreateStream):= @CgeCreateMemoryStream_;
//    pointer(Mother^.Memory.DeleteStream):= @CgeDeleteMemoryStream;
//    pointer(Mother^.Memory.SeekStream):= @CgeSeekMemoryStream;
//    pointer(Mother^.Memory.WriteToStream):= @CgeWriteToMemoryStream ;
//    pointer(Mother^.Memory.ReadFromStream):= @CgeReadFromMemoryStream;
//    pointer(Mother^.Memory.WriteIntToStream):= @CgeWriteIntToMemoryStream;
//    pointer(Mother^.Memory.ReadIntFromStream):= @CgeReadIntFromMemoryStream;
    pointer(Mother^.Memory.GetStreamMemory):= @CgeGetMemoryStreamMem;
//    pointer(Mother^.Memory.GetStreamSize):= @CgeGetMemoryStreamSize;
//    pointer(Mother^.Memory.StreamLoadFromFile):= @CgeMemoryStreamLoadFromFile;
//    pointer(Mother^.Memory.StreamSaveToFile):= @CgeMemoryStreamSaveToFile;
    pointer(Mother^.Memory.Get):= @CgeGetHostMem;
    pointer(Mother^.Memory.Free):= @CgeFreeHostMem;
    pointer(Mother^.Memory.Realloc):= @CgeReallocHostMem;

    pointer(Mother^.Stream.CreateOfFile):= @CgeCreateFileStream;
    pointer(Mother^.Stream.SetPosition):= @CgeSetStreamPosition;
    pointer(Mother^.Stream.GetPosition):= @CgeGetStreamPosition;
    pointer(Mother^.Stream.Write):= @CgeWriteToStream ;
    pointer(Mother^.Stream.Read):= @CgeReadFromStream;
    pointer(Mother^.Stream.GetSize):= @CgeGetStreamSize;
    pointer(Mother^.Stream.SetSize):= @CgeSetStreamSize;
    pointer(Mother^.Stream.Free):= @CgeFreeStream;

