
{
    This file is part of Chentrah,
    Copyright (C) 2004-2016 Anton Rzheshevski (chebmaster@mail.ru).

    This file was made by modifying a unit from FPC opengles package

    Why: need to have completerly different initialization behavior,
      unable to use the standard unit without modifying it
     (for starters, Initialization section does not work in DLLs in Linux)
    Secondly, the game DLL must receive function adresses from the mother
      executable, it should not load or initialize the GLES dll by itself


 **********************************************************************}

{$IFDEF Windows}
  {$DEFINE extdecl:=stdcall }
{$ELSE}
  {$DEFINE extdecl:=cdecl }
{$ENDIF}



(*
initialization
{$ifdef EGL}
  EGLLib:=0;
  LoadEGL({$ifdef windows}'libEGL.dll'{$else}'libEGL.so'{$endif});
{$endif}
  GLESv2Lib:=0;
  LoadGLESv2({$ifdef darwin}'/System/Library/Frameworks/OpenGLES.framework/OpenGLES'{$else}{$ifdef windows}'libGLESv2.dll'{$else}'libGLESv2.so'{$endif}{$endif});
finalization
  FreeGLESv2;
{$ifdef EGL}
  FreeEGL;
{$endif}
end.
*)

{$ifdef EGL}
  { was #define dname def_expr }
  function EGL_DEFAULT_DISPLAY : EGLNativeDisplayType;
      begin
         EGL_DEFAULT_DISPLAY:=EGLNativeDisplayType(0);
      end;

  { was #define dname def_expr }
  function EGL_NO_CONTEXT : EGLContext;
      begin
         EGL_NO_CONTEXT:=EGLContext(0);
      end;

  { was #define dname def_expr }
  function EGL_NO_DISPLAY : EGLDisplay;
      begin
         EGL_NO_DISPLAY:=EGLDisplay(0);
      end;

  { was #define dname def_expr }
  function EGL_NO_SURFACE : EGLSurface;
      begin
         EGL_NO_SURFACE:=EGLSurface(0);
      end;

  { was #define dname def_expr }
  function EGL_DONT_CARE : EGLint;
      begin
         EGL_DONT_CARE:=EGLint(-(1));
      end;

  { was #define dname def_expr }
  function EGL_UNKNOWN : EGLint;
      begin
         EGL_UNKNOWN:=EGLint(-(1));
      end;

  { was #define dname def_expr }
  function EGL_NO_IMAGE_KHR : EGLImageKHR;
      begin
         EGL_NO_IMAGE_KHR:=EGLImageKHR(0);
      end;



  procedure FreeEGL;
    begin

      eglGetError:=nil;
      eglGetDisplay:=nil;
      eglInitialize:=nil;
      eglTerminate:=nil;
      eglQueryString:=nil;
      eglGetConfigs:=nil;
      eglChooseConfig:=nil;
      eglGetConfigAttrib:=nil;
      eglCreateWindowSurface:=nil;
      eglCreatePbufferSurface:=nil;
      eglCreatePixmapSurface:=nil;
      eglDestroySurface:=nil;
      eglQuerySurface:=nil;
      eglBindAPI:=nil;
      eglQueryAPI:=nil;
      eglWaitClient:=nil;
      eglReleaseThread:=nil;
      eglCreatePbufferFromClientBuffer:=nil;
      eglSurfaceAttrib:=nil;
      eglBindTexImage:=nil;
      eglReleaseTexImage:=nil;
      eglSwapInterval:=nil;
      eglCreateContext:=nil;
      eglDestroyContext:=nil;
      eglMakeCurrent:=nil;
      eglGetCurrentContext:=nil;
      eglGetCurrentSurface:=nil;
      eglGetCurrentDisplay:=nil;
      eglQueryContext:=nil;
      eglWaitGL:=nil;
      eglWaitNative:=nil;
      eglSwapBuffers:=nil;
      eglCopyBuffers:=nil;
      eglGetProcAddress:=nil;
    end;


  procedure InitEGLProcAddresses;
    begin
      FreeEGL;

      pointer(eglGetProcAddress):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('glGetProcAddress');
      if not Assigned(eglGetProcAddress)
        then pointer(eglGetProcAddress):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglGetProcAddress');

      pointer(eglGetError):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglGetError');
      pointer(eglGetDisplay):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglGetDisplay');
      pointer(eglInitialize):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglInitialize');
      pointer(eglTerminate):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglTerminate');
      pointer(eglQueryString):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglQueryString');
      pointer(eglGetConfigs):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglGetConfigs');
      pointer(eglChooseConfig):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglChooseConfig');
      pointer(eglGetConfigAttrib):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglGetConfigAttrib');
      pointer(eglCreateWindowSurface):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglCreateWindowSurface');
      pointer(eglCreatePbufferSurface):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglCreatePbufferSurface');
      pointer(eglCreatePixmapSurface):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglCreatePixmapSurface');
      pointer(eglDestroySurface):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglDestroySurface');
      pointer(eglQuerySurface):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglQuerySurface');
      pointer(eglBindAPI):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglBindAPI');
      pointer(eglQueryAPI):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglQueryAPI');
      pointer(eglWaitClient):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglWaitClient');
      pointer(eglReleaseThread):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglReleaseThread');
      pointer(eglCreatePbufferFromClientBuffer):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglCreatePbufferFromClientBuffer');
      pointer(eglSurfaceAttrib):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglSurfaceAttrib');
      pointer(eglBindTexImage):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglBindTexImage');
      pointer(eglReleaseTexImage):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglReleaseTexImage');
      pointer(eglSwapInterval):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglSwapInterval');
      pointer(eglCreateContext):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglCreateContext');
      pointer(eglDestroyContext):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglDestroyContext');
      pointer(eglMakeCurrent):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglMakeCurrent');
      pointer(eglGetCurrentContext):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglGetCurrentContext');
      pointer(eglGetCurrentSurface):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglGetCurrentSurface');
      pointer(eglGetCurrentDisplay):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglGetCurrentDisplay');
      pointer(eglQueryContext):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglQueryContext');
      pointer(eglWaitGL):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglWaitGL');
      pointer(eglWaitNative):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglWaitNative');
      pointer(eglSwapBuffers):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglSwapBuffers');
      pointer(eglCopyBuffers):= {$ifdef cgekernel}GetEGLProcAddress{$else}GetGLProcAddress{$endif}('eglCopyBuffers');
    end;
{$endif EGL}


  procedure FreeGLESv2;
    begin

      glActiveTexture:=nil;
      glAttachShader:=nil;
      glBindAttribLocation:=nil;
      glBindBuffer:=nil;
      glBindFramebuffer:=nil;
      glBindRenderbuffer:=nil;
      glBindTexture:=nil;
      glBlendColor:=nil;
      glBlendEquation:=nil;
      glBlendEquationSeparate:=nil;
      glBlendFunc:=nil;
      glBlendFuncSeparate:=nil;
      glBufferData:=nil;
      glBufferSubData:=nil;
      glCheckFramebufferStatus:=nil;
      glClear:=nil;
      glClearColor:=nil;
      glClearDepthf:=nil;
      glClearStencil:=nil;
      glColorMask:=nil;
      glCompileShader:=nil;
      glCompressedTexImage2D:=nil;
      glCompressedTexSubImage2D:=nil;
      glCopyTexImage2D:=nil;
      glCopyTexSubImage2D:=nil;
      glCreateProgram:=nil;
      glCreateShader:=nil;
      glCullFace:=nil;
      glDeleteBuffers:=nil;
      glDeleteFramebuffers:=nil;
      glDeleteProgram:=nil;
      glDeleteRenderbuffers:=nil;
      glDeleteShader:=nil;
      glDeleteTextures:=nil;
      glDepthFunc:=nil;
      glDepthMask:=nil;
      glDepthRangef:=nil;
      glDetachShader:=nil;
      glDisable:=nil;
      glDisableVertexAttribArray:=nil;
      glDrawArrays:=nil;
      glDrawElements:=nil;
      glEnable:=nil;
      glEnableVertexAttribArray:=nil;
      glFinish:=nil;
      glFlush:=nil;
      glFramebufferRenderbuffer:=nil;
      glFramebufferTexture2D:=nil;
      glFrontFace:=nil;
      glGenBuffers:=nil;
      glGenerateMipmap:=nil;
      glGenFramebuffers:=nil;
      glGenRenderbuffers:=nil;
      glGenTextures:=nil;
      glGetActiveAttrib:=nil;
      glGetActiveUniform:=nil;
      glGetAttachedShaders:=nil;
      glGetAttribLocation:=nil;
      glGetBooleanv:=nil;
      glGetBufferParameteriv:=nil;
      glGetError:=nil;
      glGetFloatv:=nil;
      glGetFramebufferAttachmentParameteriv:=nil;
      glGetIntegerv:=nil;
      glGetProgramiv:=nil;
      glGetProgramInfoLog:=nil;
      glGetRenderbufferParameteriv:=nil;
      glGetShaderiv:=nil;
      glGetShaderInfoLog:=nil;
      glGetShaderPrecisionFormat:=nil;
      glGetShaderSource:=nil;
      glGetString:=nil;
      glGetTexParameterfv:=nil;
      glGetTexParameteriv:=nil;
      glGetUniformfv:=nil;
      glGetUniformiv:=nil;
      glGetUniformLocation:=nil;
      glGetVertexAttribfv:=nil;
      glGetVertexAttribiv:=nil;
      glGetVertexAttribPointerv:=nil;
      glHint:=nil;
      glIsBuffer:=nil;
      glIsEnabled:=nil;
      glIsFramebuffer:=nil;
      glIsProgram:=nil;
      glIsRenderbuffer:=nil;
      glIsShader:=nil;
      glIsTexture:=nil;
      glLineWidth:=nil;
      glLinkProgram:=nil;
      glPixelStorei:=nil;
      glPolygonOffset:=nil;
      glReadPixels:=nil;
      glReleaseShaderCompiler:=nil;
      glRenderbufferStorage:=nil;
      glSampleCoverage:=nil;
      glScissor:=nil;
      glShaderBinary:=nil;
      glShaderSource:=nil;
      glStencilFunc:=nil;
      glStencilFuncSeparate:=nil;
      glStencilMask:=nil;
      glStencilMaskSeparate:=nil;
      glStencilOp:=nil;
      glStencilOpSeparate:=nil;
      glTexImage2D:=nil;
      glTexParameterf:=nil;
      glTexParameterfv:=nil;
      glTexParameteri:=nil;
      glTexParameteriv:=nil;
      glTexSubImage2D:=nil;
      glUniform1f:=nil;
      glUniform1fv:=nil;
      glUniform1i:=nil;
      glUniform1iv:=nil;
      glUniform2f:=nil;
      glUniform2fv:=nil;
      glUniform2i:=nil;
      glUniform2iv:=nil;
      glUniform3f:=nil;
      glUniform3fv:=nil;
      glUniform3i:=nil;
      glUniform3iv:=nil;
      glUniform4f:=nil;
      glUniform4fv:=nil;
      glUniform4i:=nil;
      glUniform4iv:=nil;
      glUniformMatrix2fv:=nil;
      glUniformMatrix3fv:=nil;
      glUniformMatrix4fv:=nil;
      glUseProgram:=nil;
      glValidateProgram:=nil;
      glVertexAttrib1f:=nil;
      glVertexAttrib1fv:=nil;
      glVertexAttrib2f:=nil;
      glVertexAttrib2fv:=nil;
      glVertexAttrib3f:=nil;
      glVertexAttrib3fv:=nil;
      glVertexAttrib4f:=nil;
      glVertexAttrib4fv:=nil;
      glVertexAttribPointer:=nil;
      glViewport:=nil;
      glEGLImageTargetTexture2DOES:=nil;
      glEGLImageTargetRenderbufferStorageOES:=nil;
      glGetProgramBinaryOES:=nil;
      glProgramBinaryOES:=nil;
      glMapBufferOES:=nil;
      glUnmapBufferOES:=nil;
      glGetBufferPointervOES:=nil;
      glTexImage3DOES:=nil;
      glTexSubImage3DOES:=nil;
      glCopyTexSubImage3DOES:=nil;
      glCompressedTexImage3DOES:=nil;
      glCompressedTexSubImage3DOES:=nil;
      glFramebufferTexture3DOES:=nil;
      glGetPerfMonitorGroupsAMD:=nil;
      glGetPerfMonitorCountersAMD:=nil;
      glGetPerfMonitorGroupStringAMD:=nil;
      glGetPerfMonitorCounterStringAMD:=nil;
      glGetPerfMonitorCounterInfoAMD:=nil;
      glGenPerfMonitorsAMD:=nil;
      glDeletePerfMonitorsAMD:=nil;
      glSelectPerfMonitorCountersAMD:=nil;
      glBeginPerfMonitorAMD:=nil;
      glEndPerfMonitorAMD:=nil;
      glGetPerfMonitorCounterDataAMD:=nil;
    end;


  procedure InitGLESv2ProcAddresses;
    begin
      FreeGLESv2;

      pointer(glActiveTexture):= GetGLProcAddress('glActiveTexture');
      pointer(glAttachShader):= GetGLProcAddress('glAttachShader');
      pointer(glBindAttribLocation):= GetGLProcAddress('glBindAttribLocation');
      pointer(glBindBuffer):= GetGLProcAddress('glBindBuffer');
      pointer(glBindFramebuffer):= GetGLProcAddress('glBindFramebuffer');
      pointer(glBindRenderbuffer):= GetGLProcAddress('glBindRenderbuffer');
      pointer(glBindTexture):= GetGLProcAddress('glBindTexture');
      pointer(glBlendColor):= GetGLProcAddress('glBlendColor');
      pointer(glBlendEquation):= GetGLProcAddress('glBlendEquation');
      pointer(glBlendEquationSeparate):= GetGLProcAddress('glBlendEquationSeparate');
      pointer(glBlendFunc):= GetGLProcAddress('glBlendFunc');
      pointer(glBlendFuncSeparate):= GetGLProcAddress('glBlendFuncSeparate');
      pointer(glBufferData):= GetGLProcAddress('glBufferData');
      pointer(glBufferSubData):= GetGLProcAddress('glBufferSubData');
      pointer(glCheckFramebufferStatus):= GetGLProcAddress('glCheckFramebufferStatus');
      pointer(glClear):= GetGLProcAddress('glClear');
      pointer(glClearColor):= GetGLProcAddress('glClearColor');
      pointer(glClearDepthf):= GetGLProcAddress('glClearDepthf');
      pointer(glClearStencil):= GetGLProcAddress('glClearStencil');
      pointer(glColorMask):= GetGLProcAddress('glColorMask');
      pointer(glCompileShader):= GetGLProcAddress('glCompileShader');
      pointer(glCompressedTexImage2D):= GetGLProcAddress('glCompressedTexImage2D');
      pointer(glCompressedTexSubImage2D):= GetGLProcAddress('glCompressedTexSubImage2D');
      pointer(glCopyTexImage2D):= GetGLProcAddress('glCopyTexImage2D');
      pointer(glCopyTexSubImage2D):= GetGLProcAddress('glCopyTexSubImage2D');
      pointer(glCreateProgram):= GetGLProcAddress('glCreateProgram');
      pointer(glCreateShader):= GetGLProcAddress('glCreateShader');
      pointer(glCullFace):= GetGLProcAddress('glCullFace');
      pointer(glDeleteBuffers):= GetGLProcAddress('glDeleteBuffers');
      pointer(glDeleteFramebuffers):= GetGLProcAddress('glDeleteFramebuffers');
      pointer(glDeleteProgram):= GetGLProcAddress('glDeleteProgram');
      pointer(glDeleteRenderbuffers):= GetGLProcAddress('glDeleteRenderbuffers');
      pointer(glDeleteShader):= GetGLProcAddress('glDeleteShader');
      pointer(glDeleteTextures):= GetGLProcAddress('glDeleteTextures');
      pointer(glDepthFunc):= GetGLProcAddress('glDepthFunc');
      pointer(glDepthMask):= GetGLProcAddress('glDepthMask');
      pointer(glDepthRangef):= GetGLProcAddress('glDepthRangef');
      pointer(glDetachShader):= GetGLProcAddress('glDetachShader');
      pointer(glDisable):= GetGLProcAddress('glDisable');
      pointer(glDisableVertexAttribArray):= GetGLProcAddress('glDisableVertexAttribArray');
      pointer(glDrawArrays):= GetGLProcAddress('glDrawArrays');
      pointer(glDrawElements):= GetGLProcAddress('glDrawElements');
      pointer(glEnable):= GetGLProcAddress('glEnable');
      pointer(glEnableVertexAttribArray):= GetGLProcAddress('glEnableVertexAttribArray');
      pointer(glFinish):= GetGLProcAddress('glFinish');
      pointer(glFlush):= GetGLProcAddress('glFlush');
      pointer(glFramebufferRenderbuffer):= GetGLProcAddress('glFramebufferRenderbuffer');
      pointer(glFramebufferTexture2D):= GetGLProcAddress('glFramebufferTexture2D');
      pointer(glFrontFace):= GetGLProcAddress('glFrontFace');
      pointer(glGenBuffers):= GetGLProcAddress('glGenBuffers');
      pointer(glGenerateMipmap):= GetGLProcAddress('glGenerateMipmap');
      pointer(glGenFramebuffers):= GetGLProcAddress('glGenFramebuffers');
      pointer(glGenRenderbuffers):= GetGLProcAddress('glGenRenderbuffers');
      pointer(glGenTextures):= GetGLProcAddress('glGenTextures');
      pointer(glGetActiveAttrib):= GetGLProcAddress('glGetActiveAttrib');
      pointer(glGetActiveUniform):= GetGLProcAddress('glGetActiveUniform');
      pointer(glGetAttachedShaders):= GetGLProcAddress('glGetAttachedShaders');
      pointer(glGetAttribLocation):= GetGLProcAddress('glGetAttribLocation');
      pointer(glGetBooleanv):= GetGLProcAddress('glGetBooleanv');
      pointer(glGetBufferParameteriv):= GetGLProcAddress('glGetBufferParameteriv');
      pointer(glGetError):= GetGLProcAddress('glGetError');
      pointer(glGetFloatv):= GetGLProcAddress('glGetFloatv');
      pointer(glGetFramebufferAttachmentParameteriv):= GetGLProcAddress('glGetFramebufferAttachmentParameteriv');
      pointer(glGetIntegerv):= GetGLProcAddress('glGetIntegerv');
      pointer(glGetProgramiv):= GetGLProcAddress('glGetProgramiv');
      pointer(glGetProgramInfoLog):= GetGLProcAddress('glGetProgramInfoLog');
      pointer(glGetRenderbufferParameteriv):= GetGLProcAddress('glGetRenderbufferParameteriv');
      pointer(glGetShaderiv):= GetGLProcAddress('glGetShaderiv');
      pointer(glGetShaderInfoLog):= GetGLProcAddress('glGetShaderInfoLog');
      pointer(glGetShaderPrecisionFormat):= GetGLProcAddress('glGetShaderPrecisionFormat');
      pointer(glGetShaderSource):= GetGLProcAddress('glGetShaderSource');
      pointer(glGetString):= GetGLProcAddress('glGetString');
      pointer(glGetTexParameterfv):= GetGLProcAddress('glGetTexParameterfv');
      pointer(glGetTexParameteriv):= GetGLProcAddress('glGetTexParameteriv');
      pointer(glGetUniformfv):= GetGLProcAddress('glGetUniformfv');
      pointer(glGetUniformiv):= GetGLProcAddress('glGetUniformiv');
      pointer(glGetUniformLocation):= GetGLProcAddress('glGetUniformLocation');
      pointer(glGetVertexAttribfv):= GetGLProcAddress('glGetVertexAttribfv');
      pointer(glGetVertexAttribiv):= GetGLProcAddress('glGetVertexAttribiv');
      pointer(glGetVertexAttribPointerv):= GetGLProcAddress('glGetVertexAttribPointerv');
      pointer(glHint):= GetGLProcAddress('glHint');
      pointer(glIsBuffer):= GetGLProcAddress('glIsBuffer');
      pointer(glIsEnabled):= GetGLProcAddress('glIsEnabled');
      pointer(glIsFramebuffer):= GetGLProcAddress('glIsFramebuffer');
      pointer(glIsProgram):= GetGLProcAddress('glIsProgram');
      pointer(glIsRenderbuffer):= GetGLProcAddress('glIsRenderbuffer');
      pointer(glIsShader):= GetGLProcAddress('glIsShader');
      pointer(glIsTexture):= GetGLProcAddress('glIsTexture');
      pointer(glLineWidth):= GetGLProcAddress('glLineWidth');
      pointer(glLinkProgram):= GetGLProcAddress('glLinkProgram');
      pointer(glPixelStorei):= GetGLProcAddress('glPixelStorei');
      pointer(glPolygonOffset):= GetGLProcAddress('glPolygonOffset');
      pointer(glReadPixels):= GetGLProcAddress('glReadPixels');
      pointer(glReleaseShaderCompiler):= GetGLProcAddress('glReleaseShaderCompiler');
      pointer(glRenderbufferStorage):= GetGLProcAddress('glRenderbufferStorage');
      pointer(glSampleCoverage):= GetGLProcAddress('glSampleCoverage');
      pointer(glScissor):= GetGLProcAddress('glScissor');
      pointer(glShaderBinary):= GetGLProcAddress('glShaderBinary');
      pointer(glShaderSource):= GetGLProcAddress('glShaderSource');
      pointer(glStencilFunc):= GetGLProcAddress('glStencilFunc');
      pointer(glStencilFuncSeparate):= GetGLProcAddress('glStencilFuncSeparate');
      pointer(glStencilMask):= GetGLProcAddress('glStencilMask');
      pointer(glStencilMaskSeparate):= GetGLProcAddress('glStencilMaskSeparate');
      pointer(glStencilOp):= GetGLProcAddress('glStencilOp');
      pointer(glStencilOpSeparate):= GetGLProcAddress('glStencilOpSeparate');
      pointer(glTexImage2D):= GetGLProcAddress('glTexImage2D');
      pointer(glTexParameterf):= GetGLProcAddress('glTexParameterf');
      pointer(glTexParameterfv):= GetGLProcAddress('glTexParameterfv');
      pointer(glTexParameteri):= GetGLProcAddress('glTexParameteri');
      pointer(glTexParameteriv):= GetGLProcAddress('glTexParameteriv');
      pointer(glTexSubImage2D):= GetGLProcAddress('glTexSubImage2D');
      pointer(glUniform1f):= GetGLProcAddress('glUniform1f');
      pointer(glUniform1fv):= GetGLProcAddress('glUniform1fv');
      pointer(glUniform1i):= GetGLProcAddress('glUniform1i');
      pointer(glUniform1iv):= GetGLProcAddress('glUniform1iv');
      pointer(glUniform2f):= GetGLProcAddress('glUniform2f');
      pointer(glUniform2fv):= GetGLProcAddress('glUniform2fv');
      pointer(glUniform2i):= GetGLProcAddress('glUniform2i');
      pointer(glUniform2iv):= GetGLProcAddress('glUniform2iv');
      pointer(glUniform3f):= GetGLProcAddress('glUniform3f');
      pointer(glUniform3fv):= GetGLProcAddress('glUniform3fv');
      pointer(glUniform3i):= GetGLProcAddress('glUniform3i');
      pointer(glUniform3iv):= GetGLProcAddress('glUniform3iv');
      pointer(glUniform4f):= GetGLProcAddress('glUniform4f');
      pointer(glUniform4fv):= GetGLProcAddress('glUniform4fv');
      pointer(glUniform4i):= GetGLProcAddress('glUniform4i');
      pointer(glUniform4iv):= GetGLProcAddress('glUniform4iv');
      pointer(glUniformMatrix2fv):= GetGLProcAddress('glUniformMatrix2fv');
      pointer(glUniformMatrix3fv):= GetGLProcAddress('glUniformMatrix3fv');
      pointer(glUniformMatrix4fv):= GetGLProcAddress('glUniformMatrix4fv');
      pointer(glUseProgram):= GetGLProcAddress('glUseProgram');
      pointer(glValidateProgram):= GetGLProcAddress('glValidateProgram');
      pointer(glVertexAttrib1f):= GetGLProcAddress('glVertexAttrib1f');
      pointer(glVertexAttrib1fv):= GetGLProcAddress('glVertexAttrib1fv');
      pointer(glVertexAttrib2f):= GetGLProcAddress('glVertexAttrib2f');
      pointer(glVertexAttrib2fv):= GetGLProcAddress('glVertexAttrib2fv');
      pointer(glVertexAttrib3f):= GetGLProcAddress('glVertexAttrib3f');
      pointer(glVertexAttrib3fv):= GetGLProcAddress('glVertexAttrib3fv');
      pointer(glVertexAttrib4f):= GetGLProcAddress('glVertexAttrib4f');
      pointer(glVertexAttrib4fv):= GetGLProcAddress('glVertexAttrib4fv');
      pointer(glVertexAttribPointer):= GetGLProcAddress('glVertexAttribPointer');
      pointer(glViewport):= GetGLProcAddress('glViewport');
{
      pointer(glEGLImageTargetTexture2DOES):= GetGLProcAddressIgnoreMissing('glEGLImageTargetTexture2DOES');
      pointer(glEGLImageTargetRenderbufferStorageOES):= GetGLProcAddressIgnoreMissing('glEGLImageTargetRenderbufferStorageOES');
      pointer(glGetProgramBinaryOES):= GetGLProcAddressIgnoreMissing('glGetProgramBinaryOES');
      pointer(glProgramBinaryOES):= GetGLProcAddressIgnoreMissing('glProgramBinaryOES');
      pointer(glMapBufferOES):= GetGLProcAddressIgnoreMissing('glMapBufferOES');
      pointer(glUnmapBufferOES):= GetGLProcAddressIgnoreMissing('glUnmapBufferOES');
      pointer(glGetBufferPointervOES):= GetGLProcAddressIgnoreMissing('glGetBufferPointervOES');
      pointer(glTexImage3DOES):= GetGLProcAddressIgnoreMissing('glTexImage3DOES');
      pointer(glTexSubImage3DOES):= GetGLProcAddressIgnoreMissing('glTexSubImage3DOES');
      pointer(glCopyTexSubImage3DOES):= GetGLProcAddressIgnoreMissing('glCopyTexSubImage3DOES');
      pointer(glCompressedTexImage3DOES):= GetGLProcAddressIgnoreMissing('glCompressedTexImage3DOES');
      pointer(glCompressedTexSubImage3DOES):= GetGLProcAddressIgnoreMissing('glCompressedTexSubImage3DOES');
      pointer(glFramebufferTexture3DOES):= GetGLProcAddressIgnoreMissing('glFramebufferTexture3DOES');
      pointer(glGetPerfMonitorGroupsAMD):= GetGLProcAddressIgnoreMissing('glGetPerfMonitorGroupsAMD');
      pointer(glGetPerfMonitorCountersAMD):= GetGLProcAddressIgnoreMissing('glGetPerfMonitorCountersAMD');
      pointer(glGetPerfMonitorGroupStringAMD):= GetGLProcAddressIgnoreMissing('glGetPerfMonitorGroupStringAMD');
      pointer(glGetPerfMonitorCounterStringAMD):= GetGLProcAddressIgnoreMissing('glGetPerfMonitorCounterStringAMD');
      pointer(glGetPerfMonitorCounterInfoAMD):= GetGLProcAddressIgnoreMissing('glGetPerfMonitorCounterInfoAMD');
      pointer(glGenPerfMonitorsAMD):= GetGLProcAddressIgnoreMissing('glGenPerfMonitorsAMD');
      pointer(glDeletePerfMonitorsAMD):= GetGLProcAddressIgnoreMissing('glDeletePerfMonitorsAMD');
      pointer(glSelectPerfMonitorCountersAMD):= GetGLProcAddressIgnoreMissing('glSelectPerfMonitorCountersAMD');
      pointer(glBeginPerfMonitorAMD):= GetGLProcAddressIgnoreMissing('glBeginPerfMonitorAMD');
      pointer(glEndPerfMonitorAMD):= GetGLProcAddressIgnoreMissing('glEndPerfMonitorAMD');
      pointer(glGetPerfMonitorCounterDataAMD):= GetGLProcAddressIgnoreMissing('glGetPerfMonitorCounterDataAMD');
}
    end;
