operator = (a, u: TWindowManagerRect) b: System.boolean;
begin
  b:= (a.left = u.left) and (a.top = u.top) and (a.width = u.width) and (a.height = u.height);
end;

operator <> (a, u: TWindowManagerRect) b: System.boolean;
begin
  b:= (a.left <> u.left) or (a.top <> u.top) or (a.width <> u.width) or (a.height <> u.height);
end;

{
{$ifdef windows}
  {$ifdef win_unicode_fnames}
    operator := (a: TFileNameString) b: Utf8String;
    begin
      b:= Utf8Encode(a);
    end;

    operator := (a: Utf8String) b: TFileNameString;
    begin
      b:= Utf8Decode(a);
    end;

  {$else}
    operator := (a: TFileNameString) b: Utf8String;
    begin
      b:= Utf8Encode(AnsiToWide(a));
    end;

    operator := (a: Utf8String) b: TFileNameString;
    begin
      b:= WideToAnsi(Utf8Decode(a));
    end;
  {$endif}
{$endif}
}

